plugins {
	java
	id("org.springframework.boot") version "3.1.0-M2"
	id("io.spring.dependency-management") version "1.1.0"
}

group = "com.example"
version = "0.0.1-SNAPSHOT"
java.sourceCompatibility = JavaVersion.VERSION_17

repositories {
	mavenCentral()
	maven { url = uri("https://repo.spring.io/milestone") }
}

dependencies {
	implementation("org.springframework.boot:spring-boot-starter-actuator")
	implementation("org.springframework.boot:spring-boot-starter-web")
	implementation("org.springframework:spring-webflux") {
		because("WebClient for HTTP Interface clients")
	}
	testImplementation("org.springframework.boot:spring-boot-starter-test")
	testImplementation("io.rest-assured:rest-assured")
	testImplementation("com.github.tomakehurst:wiremock:3.0.0-beta-7") {
		because("For mocking downstream requests")
	}
}

tasks.withType<Test> {
	useJUnitPlatform()
}
