package com.example.demo;

import io.restassured.http.ContentType;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.server.LocalServerPort;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestPropertySource;

import static io.restassured.RestAssured.given;

@TestPropertySource("classpath:test-config.properties")
@ContextConfiguration(initializers = WireMockPortInfoApplicationContextInitializer.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
class DemoApplicationTests {

	@LocalServerPort
	private int port;

	@Test
	void testRoute() {
		given().baseUri("http://localhost:" + port)
				.when()
				.accept(ContentType.JSON)
				.get("/test")
				.then().assertThat().statusCode(200);
	}

}
