package com.example.demo;

import org.springframework.context.ApplicationContextInitializer;
import org.springframework.context.support.GenericApplicationContext;
import org.springframework.core.env.MapPropertySource;

import java.util.HashMap;
import java.util.Map;

public class WireMockPortInfoApplicationContextInitializer implements ApplicationContextInitializer<GenericApplicationContext> {

	@SuppressWarnings("unchecked")
	@Override
	public void initialize(GenericApplicationContext applicationContext) {
		var wireMockServerBootstrap = new WireMockServerBootstrap();
		wireMockServerBootstrap.start();

		var wireMockServer = wireMockServerBootstrap.getWireMockServer();

		var propertySources = applicationContext.getEnvironment().getPropertySources();
		var source = propertySources.get("server.ports");
		if (source == null) {
			source = new MapPropertySource("server.ports", new HashMap<>());
			propertySources.addFirst(source);
		}

		((Map<String, Object>) source.getSource()).put("wiremock-port", wireMockServer.port());

		applicationContext.registerBean(WireMockServerBootstrap.class, () -> wireMockServerBootstrap);
	}
}