package com.example.demo;

import com.github.tomakehurst.wiremock.WireMockServer;
import com.github.tomakehurst.wiremock.common.SingleRootFileSource;
import com.github.tomakehurst.wiremock.common.Slf4jNotifier;
import com.github.tomakehurst.wiremock.core.WireMockConfiguration;
import org.springframework.beans.factory.DisposableBean;

public class WireMockServerBootstrap implements DisposableBean {

    private final WireMockServer wireMockServer;

    public WireMockServerBootstrap() {
        this.wireMockServer = new WireMockServer(createWireMockConfig());
    }

    public void start() {
        if (!this.wireMockServer.isRunning()) {
            this.wireMockServer.start();
        }
    }

    @Override
    public void destroy() throws Exception {
        if (this.wireMockServer.isRunning()) {
            this.wireMockServer.stop();
        }
    }

    public WireMockServer getWireMockServer() {
        return this.wireMockServer;
    }

    private WireMockConfiguration createWireMockConfig() {
        return WireMockConfiguration.wireMockConfig().fileSource(new SingleRootFileSource("src/test/resources")).dynamicPort()
                .notifier(new Slf4jNotifier(true));
    }

}
